﻿//********************************************************************************
//If you should have any comments, suggestions or improvements to these samples,
//we welcome you to contact us at SampleCode@melissadata.com.
//********************************************************************************
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace Country
{
    public partial class Form1 : Form
    {
        private String[,] possibleCountries = new String[600, 10];
        private XmlNodeList nodes;

        public Form1()
        {
            InitializeComponent();
        }

        private void txtCountry_TextChanged(object sender, EventArgs e)
        {
            //take the input in City and send a request to ExpressCityState
            listBox1.Items.Clear();

            string key = id.Text.ToString().Trim();
            string query = txtCountry.Text.ToString().Trim();
            string URI = "https://expressentry.melissadata.net/web/GlobalExpressCountry?id=" + key + "&format=XML&Country=" + txtCountry.Text.Trim();

            string country;

            XmlDocument xmlin = new XmlDocument();
            xmlin.Load(URI);
            XmlElement root = xmlin.DocumentElement;
            nodes = root.SelectNodes("/Response/Results/Result");

            //Note:  no XS03 is returned from this GlobalExpressEntry endpoint!
            XmlNodeList noResultsDetector = root.SelectNodes("/Response/Results");
            if (noResultsDetector[0].InnerText.Equals(""))
            {
                listBox1.Items.Add("No Results.");
            }
            else if (txtCountry.Text.Length > 0 )
            {
                int index = 0;

                foreach (XmlNode node in nodes)  //Extract the Cities, States, and Postalcodes from the XML response
                {
                    possibleCountries[index, 0] = node["Country"].InnerText;  //native language for this country name
                    possibleCountries[index, 1] = node["English"].InnerText;  //native language for this country name
                    possibleCountries[index, 2] = node["Spanish"].InnerText;  //native language for this country name
                    possibleCountries[index, 3] = node["French"].InnerText;  //native language for this country name
                    possibleCountries[index, 4] = node["German"].InnerText;  //native language for this country name
                    possibleCountries[index, 5] = node["SimplifiedChinese"].InnerText;  //native language for this country name
                    possibleCountries[index, 6] = node["Char2ISO"].InnerText;  //native language for this country name
                    possibleCountries[index, 7] = node["Char3ISO"].InnerText;  //native language for this country name
                    possibleCountries[index, 8] = node["ISONumeric"].InnerText;  //native language for this country name
                    country = possibleCountries[index, 0];
                    listBox1.Items.Add(country);
                    index++;
                }
            }

        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

            // txtCity.Text = possibleCityStates[listBox1.SelectedIndex, 0];   //causes side effects
            Country.Text = possibleCountries[listBox1.SelectedIndex, 0];
            English.Text = possibleCountries[listBox1.SelectedIndex, 1];
            Spanish.Text = possibleCountries[listBox1.SelectedIndex, 2];
            French.Text = possibleCountries[listBox1.SelectedIndex, 3];
            German.Text = possibleCountries[listBox1.SelectedIndex, 4];
            SimpChinese.Text = possibleCountries[listBox1.SelectedIndex, 5];
            Char2ISO.Text = possibleCountries[listBox1.SelectedIndex, 6];
            Char3ISO.Text = possibleCountries[listBox1.SelectedIndex, 7];
            ISONumeric.Text = possibleCountries[listBox1.SelectedIndex, 8];

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            txtCountry.Clear();
            Country.Clear();
            English.Clear();
            Spanish.Clear();
            French.Clear();
            German.Clear();
            SimpChinese.Clear();
            Char2ISO.Clear();
            Char3ISO.Clear();
            ISONumeric.Clear();
            listBox1.Items.Clear();
            txtCountry.Focus();
        }

        private void label7_Click(object sender, EventArgs e)
        {

        }
    }
}
