﻿//********************************************************************************
//If you should have any comments, suggestions or improvements to these samples,
//we welcome you to contact us at SampleCode@melissadata.com.
//********************************************************************************
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace GlobalFieldedInput
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private const int maxRecords = 10;
        private String[,] possibleAddresses = new String[maxRecords, 5];
        private XmlNodeList nodes;

        private void txtAddress1_TextChanged(object sender, EventArgs e)
        {
            //take the input in txtPostalCode and txtAddress1 and send a request to GlobalExpressAddress
            listBox1.Items.Clear();

            string key = id.Text.ToString().Trim();
            string query = txtAddress1.Text.ToString().Trim();
            //System.Web.HttpUtility.UrlEncode(query, System.Text.Encoding.UTF8);
            string URI = "https://expressentry.melissadata.net/web/GlobalExpressAddress?id=" + key + "&format=XML&maxrecords=" + maxRecords.ToString() + "&postalcode=" + txtPostalCode.Text.Trim() + "&address1=" + txtAddress1.Text.Trim()
                + "&country=" + txtCountry.Text.Trim();

            string Address;

            XmlDocument xmlin = new XmlDocument();
            xmlin.Load(URI);
            XmlElement root = xmlin.DocumentElement;
            nodes = root.SelectNodes("/ResponseGlobal/Results/ResultGlobal/Address");

            //Detect if there is an XS03 (no results returned)
            XmlNodeList noResultsDetector = root.SelectNodes("/ResponseGlobal/ResultCode");
            if (noResultsDetector[0].InnerText.Equals("XS03"))
            {
                listBox1.Items.Add("No Results.");
            }
            else
            {
                int index = 0;

                foreach (XmlNode node in nodes)  //extract the addresses from the XML response
                {
                    possibleAddresses[index, 0] = node["DeliveryAddress1"].InnerText;
                    possibleAddresses[index, 1] = node["Locality"].InnerText;
                    possibleAddresses[index, 2] = node["AdministrativeArea"].InnerText;
                    possibleAddresses[index, 3] = node["PostalCode"].InnerText;
                    Address = possibleAddresses[index, 0] + ", " + possibleAddresses[index, 1] + " " + possibleAddresses[index, 2] + " " + possibleAddresses[index, 3];
                    listBox1.Items.Add(Address);
                    index++;
                }
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //This sample project does not explicitly support suites
            // Place the selected address into the parsed fields
            DeliveryAddress1.Text = possibleAddresses[listBox1.SelectedIndex, 0];
            Locality.Text = possibleAddresses[listBox1.SelectedIndex, 1];
            AdministrativeArea.Text = possibleAddresses[listBox1.SelectedIndex, 2];
            PostalCode.Text = possibleAddresses[listBox1.SelectedIndex, 3];
                        
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DeliveryAddress1.Clear();
            txtAddress1.Clear();
            txtPostalCode.Clear();
            Locality.Clear();
            AdministrativeArea.Clear();
            PostalCode.Clear();
            listBox1.Items.Clear();
            txtPostalCode.Focus();
        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void label10_Click(object sender, EventArgs e)
        {

        }

        private void label11_Click(object sender, EventArgs e)
        {

        }
    }
}
