﻿//********************************************************************************
//If you should have any comments, suggestions or improvements to these samples,
//we welcome you to contact us at SampleCode@melissadata.com.
//********************************************************************************
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace GlobalFreeForm
{
    public partial class Form1 : Form
    {
        private const int maxRecords = 10;  //the maximum amount of records to show in the listBox and retrieve from the service
        private String[,] possibleAddresses = new String[maxRecords, 5];
        private XmlNodeList nodes;

        public Form1()
        {
            InitializeComponent();
        }

        private void txtFreeForm_TextChanged(object sender, EventArgs e)
        {

            // Take the input in txtAddress and send a request to Express Entry
            // Clear the listBox
            listBox1.Items.Clear();

            string key = id.Text.ToString().Trim();
            string query = txtFreeForm.Text.ToString().Trim();
            //System.Web.HttpUtility.UrlEncode(query, System.Text.Encoding.UTF8);
            string URI = "https://expressentry.melissadata.net/web/GlobalExpressFreeForm?id=" + key + "&format=XML&maxrecords=" + maxRecords.ToString() + "&ff=" + query
                    + "&Country=" + txtCountry.Text.ToString().Trim();

            string Address;

            XmlDocument xmlin = new XmlDocument();
            xmlin.Load(URI);
            XmlElement root = xmlin.DocumentElement;
            nodes = root.SelectNodes("/ResponseGlobal/Results/ResultGlobal/Address");

            //Detect if there is an XS03 (no results returned)
            XmlNodeList noResultsDetector = root.SelectNodes("/ResponseGlobal/ResultCode");
            if (noResultsDetector[0].InnerText.Equals("XS03"))
            {
                listBox1.Items.Add("No Results.");
            }
            else
            {
                int index = 0;

                foreach (XmlNode node in nodes)
                {
                    possibleAddresses[index, 0] = node["DeliveryAddress1"].InnerText;
                    possibleAddresses[index, 1] = node["Locality"].InnerText;
                    possibleAddresses[index, 2] = node["AdministrativeArea"].InnerText;
                    possibleAddresses[index, 3] = node["PostalCode"].InnerText;
                    Address = possibleAddresses[index, 0] + ", " + possibleAddresses[index, 1] + " " + possibleAddresses[index, 2] + " " + possibleAddresses[index, 3];
                    listBox1.Items.Add(Address);
                    index++;
                }

            }
                        
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

            // Place the selected address into the parsed fields
            DelivAdd1.Text = possibleAddresses[listBox1.SelectedIndex, 0];
            Locality.Text = possibleAddresses[listBox1.SelectedIndex, 1];
            AdminArea.Text = possibleAddresses[listBox1.SelectedIndex, 2];
            PostalCode.Text = possibleAddresses[listBox1.SelectedIndex, 3];
            
        }

        private void button1_Click( object sender, EventArgs e)
        {
            DelivAdd1.Clear();
            Locality.Clear();
            AdminArea.Clear();
            PostalCode.Clear();
            listBox1.Items.Clear();
            txtFreeForm.Clear();
            txtFreeForm.Focus();
        }

        
    }
}
