﻿//********************************************************************************
//If you should have any comments, suggestions or improvements to these samples,
//we welcome you to contact us at SampleCode@melissadata.com.
//********************************************************************************
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace GlobalPostalCode
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private const int maxRecords = 10;
        private String[,] possibleZIPS = new String[maxRecords, 5];
        private XmlNodeList nodes;

        private void txtPostalCode_TextChanged(object sender, EventArgs e)
        {
            //take the input in txtPostalCode and send a request to GlobalExpressPostalCode
            listBox1.Items.Clear();

            string key = id.Text.ToString().Trim();
            string query = txtPostalCode.Text.ToString().Trim();
            string URI = "https://expressentry.melissadata.net/web/GlobalExpressPostalCode?id=" + key + "&format=XML&maxrecords=" + maxRecords.ToString() + "&postalcode=" + txtPostalCode.Text.Trim()
                + "&country=" + txtCountry.Text.Trim() ;

            string postalCode;

            XmlDocument xmlin = new XmlDocument();
            xmlin.Load(URI);
            XmlElement root = xmlin.DocumentElement;
            nodes = root.SelectNodes("/ResponseGlobal/Results/ResultGlobal/Address");

            //Detect if there is an XS03 (no results returned)
            XmlNodeList noResultsDetector = root.SelectNodes("/ResponseGlobal/ResultCode");
            if (noResultsDetector[0].InnerText.Equals("XS03"))
            {
                listBox1.Items.Add("No Results.");
            }
            else
            {
                int index = 0;

                foreach (XmlNode node in nodes)  //Extract the Localities, Administrative Areas, and Postal Codes from the XML response
                {
                    possibleZIPS[index, 0] = node["PostalCode"].InnerText;
                    possibleZIPS[index, 1] = node["Locality"].InnerText;
                    possibleZIPS[index, 2] = node["AdministrativeArea"].InnerText;
                    postalCode = possibleZIPS[index, 0] + ", " + possibleZIPS[index, 1] + " " + possibleZIPS[index, 2];
                    listBox1.Items.Add(postalCode);
                    index++;
                }
            }

        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

            // txtCity.Text = possibleCityStates[listBox1.SelectedIndex, 0];   //causes side effects
            PostalCode.Text = possibleZIPS[listBox1.SelectedIndex, 0];
            Locality.Text = possibleZIPS[listBox1.SelectedIndex, 1];
            AdminArea.Text = possibleZIPS[listBox1.SelectedIndex, 2];

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            txtPostalCode.Clear();
            Locality.Clear();
            AdminArea.Clear();
            PostalCode.Clear();
            listBox1.Items.Clear();
            txtPostalCode.Focus();
        }

        private void label7_Click(object sender, EventArgs e)
        {

        }

        
    }
}
