﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace GlobalThoroughfare
{
    public partial class Form1 : Form
    {
        private const int maxRecords = 10;
        private String[,] possibleThoroughfares = new String[maxRecords, 5];
        private XmlNodeList nodes;

        public Form1()
        {
            InitializeComponent();
        }

        private void txtThoroughfare_TextChanged(object sender, EventArgs e)
        {
            //take the input in Street and send a request to ExpressStreet
            listBox1.Items.Clear();

            string key = id.Text.ToString().Trim();
            //string query = txtCity.Text.ToString().Trim();
            string URI = "https://expressentry.melissadata.net/web/GlobalExpressThoroughfare?id=" + key + "&format=XML&maxrecords=" + maxRecords.ToString() + "&postalcode=" + txtPostalCode.Text.Trim() +
                    "&thoroughfare=" + txtThoroughfare.Text.Trim() + "&country=" + txtCountry.Text.Trim();

            string street;

            XmlDocument xmlin = new XmlDocument();
            xmlin.Load(URI);
            XmlElement root = xmlin.DocumentElement;
            nodes = root.SelectNodes("/ResponseGlobal/Results/ResultGlobal/Address");

            //Detect if there is an XS03 (no results returned)
            XmlNodeList noResultsDetector = root.SelectNodes("/ResponseGlobal/ResultCode");
            if (noResultsDetector[0].InnerText.Equals("XS03"))
            {
                listBox1.Items.Add("No Results.");
            }
            else
            {
                int index = 0;

                foreach (XmlNode node in nodes)  //Extract the Streets from the XML response
                {
                    possibleThoroughfares[index, 0] = node["Thoroughfare"].InnerText;
                    street = possibleThoroughfares[index, 0];
                    listBox1.Items.Add(street);
                    index++;
                }
            }

        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

            // txtCity.Text = possibleCityStates[listBox1.SelectedIndex, 0];   //causes side effects
            Thoroughfare.Text = possibleThoroughfares[listBox1.SelectedIndex, 0];

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            txtThoroughfare.Clear();
            Thoroughfare.Clear();
            listBox1.Items.Clear();
            txtPostalCode.Clear();
            txtPostalCode.Focus();
        }

        private void textBox1_TextChanged_1(object sender, EventArgs e)
        {

        }
    }
}
