﻿//********************************************************************************
//If you should have any comments, suggestions or improvements to these samples,
//we welcome you to contact us at SampleCode@melissadata.com.
//********************************************************************************
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace LocalityAdministrativeArea
{
    
    public partial class Form1 : Form
    {

        private const int maxRecords = 10;
        private String[,] possibleLocalities = new String[maxRecords, 5];
        private XmlNodeList nodes;

        public Form1()
        {
            InitializeComponent();
        }

        private void txtLocality_TextChanged(object sender, EventArgs e)
        {
            //take the input in Locality and send a request to ExpressStreet
            listBox1.Items.Clear();

            string key = id.Text.ToString().Trim();
            //string query = txtCity.Text.ToString().Trim();
            string URI = "https://expressentry.melissadata.net/web/GlobalExpressLocalityAdministrativeArea?id=" + key + "&format=XML&maxrecords=" + maxRecords.ToString() + "&locality=" + txtLocality.Text.Trim()
                            + "&country=" + Country.Text.Trim();

            string locality;

            XmlDocument xmlin = new XmlDocument();
            xmlin.Load(URI);
            XmlElement root = xmlin.DocumentElement;
            nodes = root.SelectNodes("/ResponseGlobal/Results/ResultGlobal/Address");

            //Detect if there is an XS03 (no results returned)
            XmlNodeList noResultsDetector = root.SelectNodes("/ResponseGlobal/ResultCode");
            if (noResultsDetector[0].InnerText.Equals("XS03"))
            {
                listBox1.Items.Add("No Results.");
            }
            else
            {
                int index = 0;

                foreach (XmlNode node in nodes)  //Extract the Streets from the XML response
                {
                    possibleLocalities[index, 0] = node["Locality"].InnerText;
                    possibleLocalities[index, 1] = node["AdministrativeArea"].InnerText;
                    possibleLocalities[index, 2] = node["PostalCode"].InnerText;
                    locality = possibleLocalities[index, 0] + ", " + possibleLocalities[index, 1] + " " + possibleLocalities[index,2];
                    listBox1.Items.Add(locality);
                    index++;
                }
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Locality.Text = possibleLocalities[listBox1.SelectedIndex, 0];
            AdministrativeArea.Text = possibleLocalities[listBox1.SelectedIndex, 1];
            PostalCode.Text = possibleLocalities[listBox1.SelectedIndex, 2];
        }

        private void button1_Click(object sender, EventArgs e)
        {
            txtLocality.Clear();
            Locality.Clear();
            AdministrativeArea.Clear();
            listBox1.Items.Clear();
            txtLocality.Focus();
            PostalCode.Clear();
        }

           }
}
